const gritty = require('gritty');
const http = require('http');
const express = require('express');
const io = require('socket.io');
const basicAuth = require('express-basic-auth');
const morgan = require("morgan");
const clfDate = require('@weseek/clf-date');

const app = express();
const server = http.createServer(app);
const socket = io.listen(server);

const port = 8080;
const ip = '0.0.0.0';

// get time in local tz - format as clf for lnav
morgan.token('date', function(){
  return clfDate();
})

// before auth to log unauthorized attemts
app.use(morgan('combined'));

app.use(basicAuth({
    users: { 'name': 'password' },
    challenge: true
}))

app.use(gritty());
app.use(express.static(__dirname));

gritty.listen(socket, {
    command: 'tmux a',      // optional
    autoRestart: true  // default
});

server.listen(port, ip);
